#!/bin/python3
import sys
from hamso import hamso
import matplotlib.pyplot as plt

# lay cac tham so tu dong lenh
if (len(sys.argv)<2):
	print (" Goi ham bang lenh:")
	print ("             sys.argv[0]  a b")
	print (" Trong do a, b la hai so thuc - la khoang xac dinh nghiem can tinh")
	exit(255)
	
a=float(sys.argv[1])
b=float(sys.argv[2])

# mac dinh sai so la 1e-5
if (len(sys.argv)<4):
	ssyc=1e-5
else:
	ssyc=float(sys.argv[3])

# xac dinh so buoc ve
# khong ve
buoc_ve=0
# Ve
if (len(sys.argv) == 5):
	buoc_ve=int(sys.argv[4])
	if (buoc_ve<2):
		buoc_ve=2
	elif (buoc_ve>5):
		buoc_ve=5

# tinh ham de kiem tra khoang nghiem
(fa,ga)=hamso(a)
(fb,ga)=hamso(b)

# neu khong phai khoang nghiem thi thoat
if (fa*fb>0):
	print ("Loi: ( %f ; %f ) khong phai la khoang nghem" %(a,b))
	print ("     fa = %f, fb = %f, fa*fb>0" %(fa,fb))
	sys.exit()
# ve hinh minh hoa
if (buoc_ve>0):
	fig,ax=plt.subplota()
	# ve duong dung tai a
	ax.plot((0, fa),(a, a),'k:',linewidth=0.5)
	# ve duong dung tai b
	ax.plot((0, fb),(b, b),'k:',linewidth=0.5)
	# ve duong dung tai c
	ax.plot((0, fb),(b, b),'k:',linewidth=0.5)
# khai bao ky tu de ve bang
vien_ngang='\u2500'

# Kiem tra do lon cua khoang ngiem de in bang cho phu hop
do_lon = max(abs(a),abs(b))
i=0
while (do_lon>1):
	i+=1
	do_lon /= 10
do_lon=i+8

# In tieu de bang
print (" Bang tinh ham bang phuong phap chia doi\n")
do_lon+=2
print ("\u250c%s\u252c%s\u252c%s\u252c%s\u252c%s\u252c%s\u2510" % \
        (vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*10, vien_ngang*10, vien_ngang*9))
do_lon-=2
print ("\u2502",'a'.center(do_lon, ' '),"\u2502","c".center(do_lon, ' '),"\u2502","b".center(do_lon, ' '),"\u2502", \
        "f(a)".center(8, ' '),"\u2502","f(c)".center(8, ' '),"\u2502",'sai so'.center(7, ' '),"\u2502")
do_lon+=2
print ("\u251c%s\u253c%s\u253c%s\u253c%s\u253c%s\u253c%s\u2524" % \
        (vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*10, vien_ngang*10, vien_ngang*9))
do_lon-=2

# Bat dau su dung phuong phap chia doi
# xac dinh sai so hien tai
ss=abs(a-b)/2

# Lap, moi buoc lap tinh mot buoc cua phuong phap chia doi
while (ss>ssyc):
	# Xac dinh nghiem tu khoang nghiem hien tai
	c=(a+b)/2
	# Tinh gia tri ham tai diem giua
	(fc,ga)=hamso(c)
	
	# In bang ket qua
	print ("\u2502",str(f"{a:.6f}").center(do_lon, ' '),"\u2502",str(f"{c:.6f}").center(do_lon, ' '),"\u2502", \
                str(f"{b:.6f}").center(do_lon, ' '), "\u2502",str(f"{fa:+.1e}").center(7, ' '),"\u2502", \
                str(f"{fc:+.1e}").center(7, ' '),"\u2502",str(f"{ss:.1e}").center(6,' '),"\u2502")
	
	#Kiem tra nghiem o khoang ben nao
	if (fc*fa<0):
		b=c
	else:
		a=c
		fa=fc
	# Xac dinh sai so hien tai
	ss=abs(a-b)/2
	#if (buoc_ve>0):

# Xac dinh nghiem khi sai so dat yeu cau
x=(a+b)/2
# In dong cuoi cung cua bang
print ("\u2502",str(f"{a:.6f}").center(do_lon, ' '),"\u2502",str(f"{c:.6f}").center(do_lon, ' '),"\u2502", \
                str(f"{b:.6f}").center(do_lon, ' '), "\u2502",str("--").center(8, ' '),"\u2502", \
                str("--").center(8, ' '),"\u2502",str(f"{ss:.1e}").center(7,' '),"\u2502")

# In vien duoi cua bang
do_lon+=2
print ("\u2514%s\u2534%s\u2534%s\u2534%s\u2534%s\u2534%s\u2518" % \
	(vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*10, vien_ngang*10, vien_ngang*9))

# In ket qua cuoi cung
print ("\n                    nghiem la: %.5f +- %.5f\n" % (x,ss))
#if (fig!=0):
#	fig.show()
	
